// Generated by CoffeeScript 1.8.0
(function() {
  var CategorySelectView, DATE_FORMAT, DistrictSelectView, IssueDetailsView, IssueListCountView, IssueListItemView, IssueListView, IssueMapView, IssueRouter, IssueSearchView, IssueView, LOCATIONS_FI, MAP_ATTRIBUTION, PolicymakerSelectView, RESOLUTIONS_EN, RESOLUTIONS_FI, RESOLUTIONS_ICONS, TRANSLATIONS, create_map, issue_list, router,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  DATE_FORMAT = 'D.M.YYYY';

  TRANSLATIONS = {
    "draft resolution": "Päätösesitys",
    "presenter": "Esittelijä",
    "resolution": "Päätös",
    "summary": "Yhteenveto"
  };

  LOCATIONS_FI = {
    'address': 'Osoite',
    'plan': 'Kaava',
    'plan_unit': 'Kaavayksikkö'
  };

  RESOLUTIONS_EN = {
    'PASSED': 'Passed as drafted',
    'PASSED_VOTED': 'Passed after a vote',
    'PASSED_REVISED': 'Passed revised by presenter',
    'PASSED_MODIFIED': 'Passed modified',
    'REJECTED': 'Rejected',
    'NOTED': 'Noted as informational',
    'RETURNED': 'Returned to preparation',
    'REMOVED': 'Removed from agenda',
    'TABLED': 'Tabled',
    'ELECTION': 'Election'
  };

  RESOLUTIONS_FI = {
    'PASSED': 'Ehdotuksen mukaan',
    'PASSED_VOTED': 'Ehdotuksen mukaan äänestyksin',
    'PASSED_REVISED': 'Esittelijän muutetun ehdotuksen mukaan',
    'PASSED_MODIFIED': 'Esittelijän ehdotuksesta poiketen',
    'REJECTED': 'Hylättiin',
    'NOTED': 'Merkittiin tiedoksi',
    'RETURNED': 'Palautettiin',
    'REMOVED': 'Poistettiin',
    'TABLED': 'Jätettiin pöydälle',
    'ELECTION': 'Vaali'
  };

  RESOLUTIONS_ICONS = {
    'PASSED': 'check',
    'PASSED_VOTED': 'hand-o-up',
    'PASSED_REVISED': 'check-circle-o',
    'PASSED_MODIFIED': 'check-circle',
    'REJECTED': 'trash-o',
    'NOTED': 'exclamation-circle',
    'RETURNED': 'repeat',
    'REMOVED': 'times',
    'TABLED': 'inbox',
    'ELECTION': 'group'
  };

  MAP_ATTRIBUTION = 'Map data &copy; <a href="http://openstreetmap.org">OpenStreetMap</a> contributors, <a href="http://creativecommons.org/licenses/by-sa/2.0/"> CC-BY-SA</a>, Imagery © <a href="http://cloudmade.com">CloudMade</a>';

  create_map = function(container_element, map_attribution) {
    var bounds, crs, crs_name, crs_opts, map, map_layer, opts, origin_nw, proj_def, url;
    crs_name = 'EPSG:3067';
    proj_def = '+proj=utm +zone=35 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs';
    bounds = L.bounds(L.point(-548576, 6291456), L.point(1548576, 8388608));
    origin_nw = [bounds.min.x, bounds.max.y];
    crs_opts = {
      resolutions: [8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1, 0.5, 0.25],
      bounds: bounds,
      transformation: new L.Transformation(1, -origin_nw[0], -1, origin_nw[1])
    };
    crs = new L.Proj.CRS(crs_name, proj_def, crs_opts);
    url = "http://geoserver.hel.fi/mapproxy/wmts/osm-sm/etrs_tm35fin/{z}/{x}/{y}.png";
    opts = {
      maxZoom: 15,
      minZoom: 0,
      continuousWorld: true,
      tms: false
    };
    map_layer = new L.TileLayer(url, opts);
    return map = new L.Map(container_element, {
      crs: crs,
      continuusWorld: true,
      worldCopyJump: false,
      zoomControl: false,
      attribution: map_attribution,
      layers: [map_layer]
    });
  };

  IssueView = (function(_super) {
    __extends(IssueView, _super);

    function IssueView() {
      return IssueView.__super__.constructor.apply(this, arguments);
    }

    IssueView.prototype.make_labels = function() {
      var d, districts, labels, _i, _len, _ref;
      labels = [];
      labels.push({
        text: this.model.get('top_category_name'),
        'class': 'category'
      });
      districts = {};
      _ref = this.model.get('districts');
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        d = _ref[_i];
        districts[d.name] = d;
      }
      for (d in districts) {
        labels.push({
          text: d,
          'class': 'district'
        });
      }
      return labels;
    };

    return IssueView;

  })(Backbone.View);

  IssueListItemView = (function(_super) {
    __extends(IssueListItemView, _super);

    function IssueListItemView() {
      return IssueListItemView.__super__.constructor.apply(this, arguments);
    }

    IssueListItemView.prototype.tagName = 'li';

    IssueListItemView.prototype.className = 'issue';

    IssueListItemView.prototype.template = _.template($("#issue-list-item-template").html());

    IssueListItemView.prototype.render = function() {
      var cut_amount, html, i, j, model, text;
      model = this.model.toJSON();
      model.latest_decision_date = moment(model.latest_decision_date).format(DATE_FORMAT);
      text = model.search_highlighted;
      if (text) {
        cut_amount = 200;
        i = text.indexOf('<em');
        if (i > cut_amount) {
          j = i - cut_amount;
          while (j > 0 && /[^\s]/.test(text[j])) {
            j--;
          }
          text = '... ' + text.slice(j + 1);
        }
        i = text.indexOf('/em>');
        if (text.length - i > cut_amount) {
          j = i + cut_amount;
          while (j < text.length && /[^\s]/.test(text[j])) {
            j++;
          }
          text = text.slice(0, +(j - 1) + 1 || 9e9) + '...';
        }
        model.search_highlighted = text;
      }
      model.label_list = this.make_labels();
      model.view_url = this.model.get_view_url();
      html = $($.trim(this.template(model)));
      this.$el.html(html);
      return this;
    };

    return IssueListItemView;

  })(IssueView);

  IssueListCountView = (function(_super) {
    __extends(IssueListCountView, _super);

    function IssueListCountView() {
      this.clear = __bind(this.clear, this);
      return IssueListCountView.__super__.constructor.apply(this, arguments);
    }

    IssueListCountView.prototype.el = "#result-count";

    IssueListCountView.prototype.initialize = function() {
      this.listenTo(this.collection, 'reset', this.render);
      return this.listenTo(this.collection, 'request', this.clear);
    };

    IssueListCountView.prototype.clear = function() {
      if (this.collection.length !== 0) {
        return;
      }
      return $("#result-count").hide();
    };

    IssueListCountView.prototype.render = function() {
      var res_count;
      res_count = this.collection.meta.total_count;
      $("#result-count .count").html(res_count);
      return $("#result-count").show();
    };

    return IssueListCountView;

  })(Backbone.View);

  IssueListView = (function(_super) {
    __extends(IssueListView, _super);

    function IssueListView() {
      this.handle_scroll = __bind(this.handle_scroll, this);
      return IssueListView.__super__.constructor.apply(this, arguments);
    }

    IssueListView.prototype.tagName = 'ul';

    IssueListView.prototype.className = 'issue-list-items';

    IssueListView.prototype.initialize = function() {
      this.listenTo(this.collection, 'reset', this.render);
      this.listenTo(this.collection, 'add', this.render_one);
      $(window).on('scroll', this.handle_scroll);
      return this.issue_views = [];
    };

    IssueListView.prototype.remove = function() {
      IssueListView.__super__.remove.call(this);
      return $(window).off('scroll', this.handle_scroll);
    };

    IssueListView.prototype.handle_scroll = function(ev) {
      var pixels_left, trigger_point;
      if (this.fetching || !this.rendered) {
        return;
      }
      if (this.collection.length >= this.collection.meta.total_count) {
        return;
      }
      trigger_point = 100;
      pixels_left = $(document).height() - ($(window).height() + $(window).scrollTop());
      if (pixels_left > trigger_point) {
        return;
      }
      this.fetching = true;
      this.page++;
      return this.collection.fetch({
        data: {
          page: this.page
        },
        add: true,
        remove: false,
        success: (function(_this) {
          return function() {
            return _this.fetching = false;
          };
        })(this),
        error: (function(_this) {
          return function() {
            return _this.fetching = false;
          };
        })(this),
        spinner: $(".issue-list-spinner")
      });
    };

    IssueListView.prototype.render_one = function(issue) {
      var view;
      view = new IssueListItemView({
        model: issue
      });
      this.issue_views.push(view);
      return this.$el.append(view.render().$el);
    };

    IssueListView.prototype.render = function() {
      var view, _i, _len, _ref;
      _ref = this.issue_views;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        view = _ref[_i];
        view.remove();
      }
      this.issue_views = [];
      this.page = 1;
      this.collection.each((function(_this) {
        return function(issue) {
          return _this.render_one(issue);
        };
      })(this));
      this.rendered = true;
      return this;
    };

    IssueListView.prototype.disable = function() {
      return this.disabled = true;
    };

    return IssueListView;

  })(Backbone.View);

  IssueMapView = (function(_super) {
    __extends(IssueMapView, _super);

    function IssueMapView() {
      this.map_move = __bind(this.map_move, this);
      this.remove_one = __bind(this.remove_one, this);
      this.render_one = __bind(this.render_one, this);
      return IssueMapView.__super__.constructor.apply(this, arguments);
    }

    IssueMapView.prototype.tagName = 'div';

    IssueMapView.prototype.className = 'map';

    IssueMapView.prototype.initialize = function(opts) {
      this.geometries = [];
      this.issues = {};
      this.listenTo(this.collection, 'reset', this.render);
      this.listenTo(this.collection, 'add', this.render_one);
      opts.parent_el.append(this.el);
      this.map = create_map(this.el, MAP_ATTRIBUTION).setView([60.170833, 24.9375], 12);
      return this.map.on('moveend', this.map_move);
    };

    IssueMapView.prototype.render_one = function(issue) {
      var geom, geom_json, _i, _len, _ref;
      if (!(issue.id in this.issues)) {
        _ref = issue.get('geometries');
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          geom_json = _ref[_i];
          if (geom_json.type !== 'Point') {
            continue;
          }
          geom = L.geoJson(geom_json);
          geom.bindPopup("<b>" + geom_json.name + "</b><br><a href='" + (issue.get_view_url()) + "'>" + (issue.get('subject')) + "</a>");
          geom.addTo(this.map);
          geom_json.geometry = geom;
          this.geometries.push(geom);
        }
        return this.issues[issue.id] = true;
      }
    };

    IssueMapView.prototype.remove_one = function(issue) {
      var geom_json, _i, _len, _ref, _results;
      _ref = issue.get('geometries');
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        geom_json = _ref[_i];
        if (!geom_json.geometry) {
          continue;
        }
        this.map.removeLayer(geom_json.geometry);
        _results.push(delete geom_json.geometry);
      }
      return _results;
    };

    IssueMapView.prototype.get_map_bounds = function() {
      return this.map.getBounds().pad(0.25).toBBoxString();
    };

    IssueMapView.prototype.map_move = function(ev) {
      return this.trigger("map-move", this.get_map_bounds());
    };

    IssueMapView.prototype.render = function() {
      var geom, _i, _len, _ref;
      _ref = this.geometries;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        geom = _ref[_i];
        this.map.removeLayer(geom);
      }
      this.geometries = [];
      this.issues = {};
      return this.collection.each(this.render_one);
    };

    return IssueMapView;

  })(Backbone.View);

  CategorySelectView = (function(_super) {
    __extends(CategorySelectView, _super);

    function CategorySelectView() {
      this.select_category = __bind(this.select_category, this);
      return CategorySelectView.__super__.constructor.apply(this, arguments);
    }

    CategorySelectView.prototype.el = '#category-filter';

    CategorySelectView.prototype.events = {
      'click .category-list li a': 'select_category'
    };

    CategorySelectView.prototype.initialize = function(opts) {
      this.listenTo(this.collection, 'reset', this.render);
      return this.parent_view = opts.parent_view;
    };

    CategorySelectView.prototype.make_li = function(cat, $parent) {
      var $li, $list_el, kitten, _i, _len, _ref;
      $li = $("<li><a tabindex='-1' data-cat-id='" + (cat.get('id')) + "' href='#'>" + (cat.get('origin_id')) + " " + (cat.get('name')) + "</a></li>");
      if (cat.children && cat.children.length) {
        $li.addClass("dropdown-submenu");
        $list_el = $("<ul class='dropdown-menu'></ul>");
        $li.append($list_el);
        _ref = cat.children;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          kitten = _ref[_i];
          this.make_li(kitten, $list_el);
        }
      }
      return $parent.append($li);
    };

    CategorySelectView.prototype.select_category = function(ev) {
      var cat, cat_id, el;
      ev.preventDefault();
      el = ev.currentTarget;
      cat_id = $(el).data('cat-id');
      if (!cat_id) {
        $("#category-filter input").val("");
        this.parent_view.set_filter('category', null);
        return;
      }
      cat = this.collection.findWhere({
        id: cat_id
      });
      $("#category-filter input").val("" + (cat.get('origin_id')) + " " + (cat.get('name')));
      return this.parent_view.set_filter('category', cat.get('id'));
    };

    CategorySelectView.prototype.render = function() {
      var $list, root_list;
      $list = this.$el.find('.category-list');
      $list.empty();
      $list.append($("<li><a tabindex='-1' href='#'>Ei tehtäväluokkarajausta</a></li>"));
      $list.append($("<li class='divider'></li>"));
      root_list = this.collection.filter(function(cat) {
        return cat.get('level') === 0;
      });
      return _.each(root_list, (function(_this) {
        return function(cat) {
          return _this.make_li(cat, $list);
        };
      })(this));
    };

    return CategorySelectView;

  })(Backbone.View);

  DistrictSelectView = (function(_super) {
    __extends(DistrictSelectView, _super);

    function DistrictSelectView() {
      this.select_district = __bind(this.select_district, this);
      return DistrictSelectView.__super__.constructor.apply(this, arguments);
    }

    DistrictSelectView.prototype.el = '#district-filter';

    DistrictSelectView.prototype.initialize = function(opts) {
      return this.parent_view = opts.parent_view;
    };

    DistrictSelectView.prototype.render = function() {
      var chosen_opts, district_dict, district_names, name;
      this.$el.empty();
      district_dict = {};
      this.collection.each((function(_this) {
        return function(d) {
          return district_dict[d.get('name')] = d;
        };
      })(this));
      district_names = [];
      for (name in district_dict) {
        district_names.push(name);
      }
      district_names = _.sortBy(district_names, function(x) {
        return x;
      });
      this.$el.append("<option value=''></option>");
      _.each(district_names, (function(_this) {
        return function(d) {
          var opt_el;
          opt_el = $("<option value='" + d + "'>" + d + "</option>");
          return _this.$el.append(opt_el);
        };
      })(this));
      chosen_opts = _.extend({
        allow_single_deselect: true
      }, CHOSEN_DEFAULTS);
      return this.$el.chosen(chosen_opts).change(this.select_district);
    };

    DistrictSelectView.prototype.select_district = function(ev) {
      var d_list, val;
      val = this.$el.val();
      if (val) {
        d_list = val.join(',');
      } else {
        d_list = null;
      }
      return this.parent_view.set_filter('district', d_list);
    };

    return DistrictSelectView;

  })(Backbone.View);

  PolicymakerSelectView = (function(_super) {
    __extends(PolicymakerSelectView, _super);

    function PolicymakerSelectView() {
      this.select_category = __bind(this.select_category, this);
      return PolicymakerSelectView.__super__.constructor.apply(this, arguments);
    }

    PolicymakerSelectView.prototype.el = "#policymaker-filter";

    PolicymakerSelectView.prototype.initialize = function(opts) {
      return this.parent_view = opts.parent_view;
    };

    PolicymakerSelectView.prototype.render = function() {
      this.$el.empty();
      this.collection.each((function(_this) {
        return function(pm) {
          var opt_el;
          opt_el = $("<option value='" + (pm.get('id')) + "'>" + (pm.get('name')) + "</option>");
          return _this.$el.append(opt_el);
        };
      })(this));
      return this.$el.chosen(CHOSEN_DEFAULTS).change(this.select_category);
    };

    PolicymakerSelectView.prototype.select_category = function(ev) {
      var pm_list, val, x;
      val = this.$el.val();
      if (val) {
        pm_list = ((function() {
          var _i, _len, _ref, _results;
          _ref = this.$el.val();
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            x = _ref[_i];
            _results.push(parseInt(x));
          }
          return _results;
        }).call(this)).join(',');
      } else {
        pm_list = null;
      }
      return this.parent_view.set_filter('policymaker', pm_list);
    };

    return PolicymakerSelectView;

  })(Backbone.View);

  IssueSearchView = (function(_super) {
    __extends(IssueSearchView, _super);

    function IssueSearchView() {
      this.handle_text_filter = __bind(this.handle_text_filter, this);
      return IssueSearchView.__super__.constructor.apply(this, arguments);
    }

    IssueSearchView.prototype.el = "#subpage-content-container";

    IssueSearchView.prototype.template = $("#issue-search-template").html();

    IssueSearchView.prototype.initialize = function(opts) {
      var content;
      content = $.trim(this.template);
      this.$el.html(content);
      this.pm_list = opts.pm_list;
      this.cat_list = opts.cat_list;
      this.district_list = opts.district_list;
      this.cat_select_view = new CategorySelectView({
        collection: this.cat_list,
        parent_view: this
      });
      this.cat_select_view.render();
      this.district_select_view = new DistrictSelectView({
        collection: this.district_list,
        parent_view: this
      });
      this.district_select_view.render();
      this.pm_select_view = new PolicymakerSelectView({
        collection: this.pm_list,
        parent_view: this
      });
      this.pm_select_view.render();
      if (opts.issue_list) {
        this.issue_list = opts.issue_list;
      } else {
        this.issue_list = new IssueSearchList();
      }
      this.count_view = new IssueListCountView({
        collection: this.issue_list
      });
      this.$el.find("#text-filter").change(this.handle_text_filter);
      $(".list-tab-selector .select-list").click(this.select_list);
      return $(".list-tab-selector .select-map").click(this.select_map);
    };

    IssueSearchView.prototype.handle_text_filter = function(ev) {
      var el, q, url;
      el = $(ev.target);
      q = $.trim(el.val());
      if (q) {
        this.set_filter('text', q);
      } else {
        this.set_filter('text', null);
      }
      if (window.history && window.history.replaceState) {
        url = $.param.querystring(location.href, {
          q: q
        }, 2);
        return window.history.replaceState({}, window.title, url);
      }
    };

    IssueSearchView.prototype.select_list = function() {
      return router.navigate("/", {
        trigger: true
      });
    };

    IssueSearchView.prototype.select_map = function() {
      return router.navigate("kartta/", {
        trigger: true
      });
    };

    IssueSearchView.prototype.select = function(view_type) {
      var filters, params, parent_el, text_filter;
      if (view_type === this.view_type) {
        return;
      }
      if (this.result_view) {
        this.result_view.remove();
      }
      params = $.deparam.querystring();
      filters = {};
      if ('q' in params) {
        $("#text-filter").val(params['q']);
      }
      parent_el = this.$el.find('#issue-list-items-container');
      if (view_type === 'list') {
        this.result_view = new IssueListView({
          collection: this.issue_list
        });
        this.$el.find(".list-tab-selector .select-list").addClass("active");
        this.$el.find(".list-tab-selector .select-map").removeClass("active");
        this.view_type = 'list';
        parent_el.append(this.result_view.el);
        filters.bbox = null;
      } else {
        this.result_view = new IssueMapView({
          collection: this.issue_list,
          parent_el: parent_el
        });
        this.$el.find(".list-tab-selector .select-map").addClass("active");
        this.$el.find(".list-tab-selector .select-list").removeClass("active");
        this.view_type = 'map';
        this.listenTo(this.result_view, 'map-move', this.map_move);
        filters.bbox = this.result_view.get_map_bounds();
      }
      text_filter = $("#text-filter").val();
      if (text_filter) {
        filters.text = text_filter;
      } else {
        filters.text = null;
      }
      return this.set_filters(filters);
    };

    IssueSearchView.prototype.map_move = function(args) {
      return this.set_bounding_box(args);
    };

    IssueSearchView.prototype.set_bounding_box = function(bbox) {
      this.issue_list.set_filter('bbox', bbox);
      return this.issue_list.fetch();
    };

    IssueSearchView.prototype.set_filter = function(type, query) {
      this.issue_list.set_filter(type, query);
      this.issue_list.reset();
      return this.issue_list.fetch({
        reset: true,
        spinner: $(".issue-list-spinner")
      });
    };

    IssueSearchView.prototype.set_filters = function(filters) {
      var type;
      for (type in filters) {
        this.issue_list.set_filter(type, filters[type]);
      }
      this.issue_list.reset();
      return this.issue_list.fetch({
        reset: true,
        spinner: $(".issue-list-spinner")
      });
    };

    return IssueSearchView;

  })(Backbone.View);

  IssueDetailsView = (function(_super) {
    __extends(IssueDetailsView, _super);

    function IssueDetailsView() {
      return IssueDetailsView.__super__.constructor.apply(this, arguments);
    }

    IssueDetailsView.prototype.el = "#subpage-content-container";

    IssueDetailsView.prototype.template = _.template($("#item-details-template").html());

    IssueDetailsView.prototype.meeting_template = _.template($("#meeting-template").html());

    IssueDetailsView.prototype.initialize = function(opts) {
      this.pm_list = opts.pm_list;
      return this.listenTo(this.model.agenda_item_list, 'reset', this.render);
    };

    IssueDetailsView.prototype.select_agenda_item = function(meeting_id, agenda_item_index) {
      this.meeting_id = meeting_id;
      this.agenda_item_index = agenda_item_index;
      this.render();
    };

    IssueDetailsView.prototype.render = function() {
      var current_ai_data, data, future_list, geom_json, geom_layer, geometries, html, now, past_list, preferred_max_zoom, _i, _len;
      if (!this.model.agenda_item_list.length) {
        this.model.fetch_agenda_items();
        return;
      }
      if (this.meeting_id) {
        this.current_ai = this.model.agenda_item_list.find_by_slug(this.meeting_id, this.pm_list, this.agenda_item_index);
        if (!this.current_ai) {
          throw "Agenda item with slug " + this.meeting_id + " not found";
        }
      } else {
        this.current_ai = this.model.agenda_item_list.at(0);
      }
      future_list = [];
      past_list = [];
      now = moment();
      current_ai_data = null;
      this.model.agenda_item_list.each((function(_this) {
        return function(ai) {
          var c, data, m, meeting_date, pm, _i, _len, _ref;
          meeting_date = moment(ai.get('meeting').date);
          data = ai.toJSON();
          data.meeting.date_str = meeting_date.format(DATE_FORMAT);
          data.has_non_public_attachments = ai.has_non_public_attachments();
          if (ai.id === _this.current_ai.id) {
            data.is_active = true;
            current_ai_data = data;
          } else {
            data.is_active = false;
          }
          if (data.resolution) {
            data.resolution_str = RESOLUTIONS_FI[data.resolution];
            data.resolution_icon = RESOLUTIONS_ICONS[data.resolution];
          }
          pm = _this.pm_list.get(data.meeting.policymaker);
          m = data.meeting;
          m.icon = pm.get_icon();
          m.view_url = pm.get_view_url() + ("" + m.year + "/" + m.number + "/");
          _ref = data.content;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            c = _ref[_i];
            c.type_str = TRANSLATIONS[c.type];
          }
          if (meeting_date > now) {
            return future_list.push(data);
          } else {
            return past_list.push(data);
          }
        };
      })(this));
      data = this.model.toJSON();
      data.future_list = future_list;
      data.past_list = past_list;
      data.current = current_ai_data;
      data.label_list = this.make_labels();
      data.meeting_template = this.meeting_template;
      html = $.trim(this.template(data));
      this.$el.html(html);
      geometries = this.model.get('geometries');
      if (geometries.length > 0) {
        this.$el.find('#issue-map').css('display', 'block');
        this.map = create_map('issue-map');
        this.$el.find('#map-attribution').html('<hr>' + MAP_ATTRIBUTION);
        geom_layer = L.geoJson(null, {
          onEachFeature: function(featureData, layer) {
            return layer.bindPopup("" + LOCATIONS_FI[featureData.category] + "<br> <b>" + featureData.name + "</b>");
          }
        });
        for (_i = 0, _len = geometries.length; _i < _len; _i++) {
          geom_json = geometries[_i];
          geom_layer.addData(geom_json);
          geom_json.geometry = geom_layer;
        }
        geom_layer.addTo(this.map);
        preferred_max_zoom = 16;
        this.map.fitBounds(geom_layer.getBounds(), {
          paddingBottomRight: [0, 50],
          maxZoom: preferred_max_zoom
        });
        if (this.map.getZoom() > preferred_max_zoom) {
          this.map.setZoom(preferred_max_zoom, {
            animate: false
          });
        }
      }
      return this.$el.find(".meeting-list li").click((function(_this) {
        return function(ev) {
          var ai, ai_id, has_many, has_same_meeting, issue_id, meeting_id, url;
          if (ev.target.tagName === 'A') {
            return true;
          }
          ai_id = $(ev.currentTarget).data('agenda-item-id');
          ai = _this.model.agenda_item_list.findWhere({
            id: ai_id
          });
          issue_id = _this.model.get('id');
          meeting_id = ai.get('meeting').id;
          has_same_meeting = function(agenda_item) {
            return agenda_item.get('issue').id === issue_id && agenda_item.get('meeting').id === meeting_id;
          };
          has_many = _this.model.agenda_item_list.filter(has_same_meeting).length > 1;
          url = "" + (_this.model.get('slug')) + "/" + (ai.get_slug(_this.pm_list)) + "/";
          if (has_many) {
            url += "" + (ai.get('index')) + "/";
          }
          return router.navigate(url, {
            trigger: true,
            replace: true
          });
        };
      })(this));
    };

    return IssueDetailsView;

  })(IssueView);

  IssueRouter = (function(_super) {
    __extends(IssueRouter, _super);

    function IssueRouter() {
      return IssueRouter.__super__.constructor.apply(this, arguments);
    }

    IssueRouter.prototype.routes = {
      "": "issue_list_view",
      "kartta/": "issue_map_view",
      ":issue/": "issue_details_view",
      ":issue/:meeting/": "issue_details_view",
      ":issue/:meeting/:index/": "issue_details_view"
    };

    IssueRouter.prototype.initialize = function() {
      this.current_view = null;
      this.cat_list = new CategoryList(cat_list_json);
      this.pm_list = new PolicymakerList(pm_list_json);
      return this.district_list = new DistrictList(district_list_json);
    };

    IssueRouter.prototype.ensure_view = function(type, model) {
      if (type === 'search') {
        if (!this.current_view instanceof IssueSearchView) {
          this.current_view.remove();
        }
        this.current_view = new IssueSearchView({
          cat_list: this.cat_list,
          pm_list: this.pm_list,
          district_list: this.district_list
        });
        return this.issue_list = this.current_view.issue_list;
      } else {
        if (!this.current_view instanceof IssueDetailsView) {
          this.current_view.remove();
        }
        return this.current_view = new IssueDetailsView({
          model: model,
          cat_list: this.cat_list,
          pm_list: this.pm_list,
          district_list: this.district_list
        });
      }
    };

    IssueRouter.prototype.issue_list_view = function() {
      this.ensure_view('search');
      return this.current_view.select('list');
    };

    IssueRouter.prototype.issue_map_view = function() {
      this.ensure_view('search');
      return this.current_view.select('map');
    };

    IssueRouter.prototype.issue_details_view = function(issue, meeting, index) {
      var model;
      model = this.issue_list.findWhere({
        slug: issue
      });
      this.ensure_view('details', model);
      return this.current_view.select_agenda_item(meeting, index);
    };

    return IssueRouter;

  })(Backbone.Router);

  router = new IssueRouter;

  if (typeof issue_json !== 'undefined') {
    issue_list = new IssueList([issue_json]);
    issue_list.at(0).agenda_item_list.reset(ai_list_json, {
      silent: true
    });
    router.issue_list = issue_list;
  }

  Backbone.history.start({
    pushState: true,
    hashChange: false,
    root: VIEW_URLS['issue-list']
  });

}).call(this);
