// Generated by CoffeeScript 1.8.0
(function() {
  var install_spinner, old_ajax;

  old_ajax = Backbone.ajax;

  install_spinner = function(opts, data) {
    var el, error, start_spinning, success, timeout;
    if (data instanceof jQuery) {
      data = {
        el: opts.spinner
      };
    }
    el = data.el;
    start_spinning = function() {
      var args;
      args = _.extend({
        hwaccel: true
      }, data);
      return el.spin(args);
    };
    timeout = setTimeout(start_spinning, 200);
    success = opts.success;
    opts.success = function(resp) {
      clearTimeout(timeout);
      el.spin(false);
      if (success) {
        return success(resp);
      }
    };
    error = opts.error;
    return opts.error = function(resp) {
      clearTimeout(timeout);
      el.spin(false);
      if (error) {
        return error(resp);
      }
    };
  };

  Backbone.ajax = function() {
    var opts;
    opts = arguments[0];
    if (opts && opts.spinner) {
      install_spinner(opts, opts.spinner);
    }
    return old_ajax.apply(Backbone, arguments);
  };

}).call(this);

// Generated by CoffeeScript 1.8.0
(function() {
  var POLICYMAKERS,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  this.Category = (function(_super) {
    __extends(Category, _super);

    function Category() {
      return Category.__super__.constructor.apply(this, arguments);
    }

    return Category;

  })(Backbone.Tastypie.Model);

  this.CategoryList = (function(_super) {
    __extends(CategoryList, _super);

    function CategoryList() {
      this.find_children = __bind(this.find_children, this);
      return CategoryList.__super__.constructor.apply(this, arguments);
    }

    CategoryList.prototype.urlRoot = API_PREFIX + 'v1/category';

    CategoryList.prototype.model = Category;

    CategoryList.prototype.comparator = function(cat) {
      return "" + (cat.get('level')) + " " + (cat.get('origin_id'));
    };

    CategoryList.prototype.reset = function(models, options) {
      CategoryList.__super__.reset.call(this, models, options);
      return this.each(this.find_children);
    };

    CategoryList.prototype.find_children = function(cat) {
      return cat.children = this.get_children(cat);
    };

    CategoryList.prototype.get_children = function(parent) {
      return this.filter(function(m) {
        return m.get('parent') === parent.id;
      });
    };

    return CategoryList;

  })(Backbone.Tastypie.Collection);

  this.Issue = (function(_super) {
    __extends(Issue, _super);

    function Issue() {
      return Issue.__super__.constructor.apply(this, arguments);
    }

    Issue.prototype.initialize = function() {
      this.agenda_item_list = new AgendaItemList;
      this.agenda_item_list.filters['issue'] = this.get('id');
      return this.agenda_item_list.filters['limit'] = 1000;
    };

    Issue.prototype.fetch_agenda_items = function() {
      if (this.agenda_item_list.length) {
        this.agenda_item_list.trigger('reset');
        return;
      }
      return this.agenda_item_list.fetch({
        reset: true
      });
    };

    Issue.prototype.get_view_url = function() {
      return VIEW_URLS['issue-details'].replace('ID', this.get('slug'));
    };

    return Issue;

  })(Backbone.Tastypie.Model);

  this.IssueList = (function(_super) {
    __extends(IssueList, _super);

    function IssueList() {
      return IssueList.__super__.constructor.apply(this, arguments);
    }

    IssueList.prototype.urlRoot = API_PREFIX + 'v1/issue/';

    IssueList.prototype.model = Issue;

    return IssueList;

  })(Backbone.Tastypie.Collection);

  this.IssueSearchList = (function(_super) {
    __extends(IssueSearchList, _super);

    IssueSearchList.prototype.urlRoot = API_PREFIX + 'v1/issue/search/';

    IssueSearchList.prototype.model = Issue;

    function IssueSearchList(models, options) {
      IssueSearchList.__super__.constructor.call(this, models, options);
      this.filters['order_by'] = '-latest_decision_date';
    }

    IssueSearchList.prototype.set_filter = function(type, val) {
      var filter_name;
      filter_name = type;
      if (!val) {
        if (filter_name in this.filters) {
          return delete this.filters[filter_name];
        }
      } else {
        return this.filters[filter_name] = val;
      }
    };

    return IssueSearchList;

  })(Backbone.Tastypie.Collection);

  this.AgendaItem = (function(_super) {
    __extends(AgendaItem, _super);

    function AgendaItem() {
      return AgendaItem.__super__.constructor.apply(this, arguments);
    }

    AgendaItem.prototype.get_slug = function(pm_list) {
      var meeting, pm, slug;
      meeting = this.get('meeting');
      pm = pm_list.get(meeting.policymaker);
      slug = "" + (pm.get('slug')) + "-" + meeting.year + "-" + meeting.number;
      return slug;
    };

    AgendaItem.prototype.get_view_url = function(issue, pm_list) {
      var slug;
      slug = this.get_slug(pm_list);
      return issue.get_view_url() + slug + '/';
    };

    AgendaItem.prototype.has_non_public_attachments = function() {
      var att, _i, _len, _ref;
      _ref = this.get('attachments');
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        att = _ref[_i];
        if (!att["public"]) {
          return true;
        }
      }
      return false;
    };

    return AgendaItem;

  })(Backbone.Tastypie.Model);

  this.AgendaItemList = (function(_super) {
    __extends(AgendaItemList, _super);

    function AgendaItemList() {
      return AgendaItemList.__super__.constructor.apply(this, arguments);
    }

    AgendaItemList.prototype.urlRoot = API_PREFIX + 'v1/agenda_item/';

    AgendaItemList.prototype.model = AgendaItem;

    AgendaItemList.prototype.comparator = function(ai1, ai2) {
      var diff, string_diff;
      string_diff = function(s1, s2) {
        if (s1 < s2) {
          return -1;
        }
        if (s1 === s2) {
          return 0;
        }
        return 1;
      };
      diff = string_diff(ai1.get('meeting').date, ai2.get('meeting').date);
      if (diff === 0) {
        return ai1.get('index') - ai2.get('index');
      }
      return -diff;
    };

    AgendaItemList.prototype.find_by_slug = function(slug, pm_list, index) {
      var number, parts, pm, pm_slug, year;
      parts = slug.split('-');
      pm_slug = parts[0];
      year = parseInt(parts[1]);
      number = parseInt(parts[2]);
      pm = pm_list.findWhere({
        slug: pm_slug
      });
      return this.find(function(ai) {
        var meeting;
        meeting = ai.get('meeting');
        if (meeting.policymaker !== pm.id) {
          return false;
        }
        if (meeting.year !== year || meeting.number !== number) {
          return false;
        }
        if ((index != null) && ("" + (ai.get('index'))) !== ("" + index)) {
          return false;
        }
        return true;
      });
    };

    return AgendaItemList;

  })(Backbone.Tastypie.Collection);

  this.Meeting = (function(_super) {
    __extends(Meeting, _super);

    function Meeting() {
      return Meeting.__super__.constructor.apply(this, arguments);
    }

    Meeting.prototype.get_view_url = function() {
      var pm;
      pm = this.collection.policymaker_list.get(this.get('policymaker'));
      return pm.get_view_url() + ("" + (this.get('year')) + "/" + (this.get('number')) + "/");
    };

    Meeting.prototype.initialize = function() {
      this.agenda_item_list = new AgendaItemList;
      this.agenda_item_list.filters['meeting'] = this.get('id');
      this.agenda_item_list.filters['limit'] = 1000;
      return this.agenda_item_list.filters['show_all'] = 1;
    };

    Meeting.prototype.fetch_agenda_items = function() {
      if (this.agenda_item_list.length) {
        this.agenda_item_list.trigger('reset');
        return;
      }
      return this.agenda_item_list.fetch({
        reset: true
      });
    };

    return Meeting;

  })(Backbone.Tastypie.Model);

  this.MeetingList = (function(_super) {
    __extends(MeetingList, _super);

    function MeetingList() {
      return MeetingList.__super__.constructor.apply(this, arguments);
    }

    MeetingList.prototype.urlRoot = API_PREFIX + 'v1/meeting/';

    MeetingList.prototype.model = Meeting;

    MeetingList.prototype.initialize = function(models, opts) {
      return this.policymaker_list = opts.policymaker_list;
    };

    return MeetingList;

  })(Backbone.Tastypie.Collection);

  POLICYMAKERS = {
    'Aslk': {
      icon: 'home'
    },
    'Asuntk': {
      icon: 'home'
    },
    'Zoojk': {
      icon: 'bug'
    },
    'Oivajk': {
      icon: 'group'
    },
    'Koja': {
      icon: 'briefcase'
    },
    'Sote': {
      icon: 'medkit'
    },
    'Khs': {
      icon: 'legal'
    },
    'Museojk': {
      icon: 'asterisk'
    },
    'Kvsto': {
      icon: 'microphone'
    },
    'Kslk': {
      icon: 'eraser'
    },
    'Kvlk': {
      icon: 'ticket'
    },
    'Klk': {
      icon: 'building-o'
    },
    'Kklk': {
      icon: 'picture-o'
    },
    'HKLjk': {
      icon: 'road'
    },
    'LILK': {
      icon: 'trophy'
    },
    'Nlk': {
      icon: 'smile-o'
    },
    'SKJ': {
      icon: 'pencil'
    },
    'OLK': {
      icon: 'pencil'
    },
    'Palmiajk': {
      icon: 'leaf'
    },
    'PELK': {
      icon: 'fire-extinguisher'
    },
    'Sotelk': {
      icon: 'medkit'
    },
    'Soslk': {
      icon: 'heart'
    },
    'Stojk': {
      icon: 'book'
    },
    'Taimujk': {
      icon: 'asterisk'
    },
    'Talpajk': {
      icon: 'euro'
    },
    'Talk': {
      icon: 'eye'
    },
    'Tija': {
      icon: 'laptop'
    },
    'Tplk': {
      icon: 'cog'
    },
    'Tervlk': {
      icon: 'user-md'
    },
    'Vakalk': {
      icon: 'puzzle-piece'
    },
    'Ytlk': {
      icon: 'wrench'
    },
    'Ylk': {
      icon: 'leaf'
    }
  };

  this.Policymaker = (function(_super) {
    __extends(Policymaker, _super);

    function Policymaker() {
      return Policymaker.__super__.constructor.apply(this, arguments);
    }

    Policymaker.prototype.initialize = function() {
      this.meeting_list = new MeetingList(null, {
        policymaker_list: this.collection
      });
      this.meeting_list.filters['policymaker'] = this.get('id');
      return this.meeting_list.filters['limit'] = 1000;
    };

    Policymaker.prototype.get_view_url = function() {
      return VIEW_URLS['policymaker-details'].replace('ID', this.get('slug'));
    };

    Policymaker.prototype.get_category = function() {
      var ALLOWED_TYPES, abbrev, _ref;
      abbrev = this.get('abbreviation');
      ALLOWED_TYPES = ['board', 'division', 'council', 'board_division', 'office_holder', 'committee'];
      if (_ref = this.get('org_type'), __indexOf.call(ALLOWED_TYPES, _ref) >= 0) {
        return this.get('org_type');
      } else {
        return 'other';
      }
    };

    Policymaker.prototype.get_icon = function() {
      var pm_info;
      pm_info = POLICYMAKERS[this.get('abbreviation')];
      if (!pm_info) {
        return null;
      }
      return pm_info.icon;
    };

    Policymaker.prototype.fetch_meetings = function() {
      if (this.meeting_list.length) {
        this.meeting_list.trigger('reset');
        return;
      }
      return this.meeting_list.fetch({
        reset: true
      });
    };

    return Policymaker;

  })(Backbone.Tastypie.Model);

  this.PolicymakerList = (function(_super) {
    __extends(PolicymakerList, _super);

    function PolicymakerList() {
      return PolicymakerList.__super__.constructor.apply(this, arguments);
    }

    PolicymakerList.prototype.urlRoot = API_PREFIX + 'v1/policymaker/';

    PolicymakerList.prototype.model = Policymaker;

    PolicymakerList.prototype.comparator = function(pm) {
      var PRIORITIES, cat;
      cat = pm.get_category();
      PRIORITIES = {
        'council': 0,
        'government': 1,
        'committee': 2,
        'board': 2,
        'other': 2
      };
      return "" + PRIORITIES[cat] + " " + (pm.get('name'));
    };

    return PolicymakerList;

  })(Backbone.Tastypie.Collection);

  this.District = (function(_super) {
    __extends(District, _super);

    function District() {
      return District.__super__.constructor.apply(this, arguments);
    }

    return District;

  })(Backbone.Tastypie.Model);

  this.DistrictList = (function(_super) {
    __extends(DistrictList, _super);

    function DistrictList() {
      return DistrictList.__super__.constructor.apply(this, arguments);
    }

    DistrictList.prototype.urlRoot = API_PREFIX + 'v1/district';

    DistrictList.prototype.model = District;

    return DistrictList;

  })(Backbone.Tastypie.Collection);

  this.Organization = (function(_super) {
    __extends(Organization, _super);

    function Organization() {
      return Organization.__super__.constructor.apply(this, arguments);
    }

    Organization.prototype.url = function() {
      return API_PREFIX + 'v1/organization/' + encodeURIComponent(this.get('id')) + '/';
    };

    Organization.prototype.toJSON = function(opts) {
      var c, ret, _i, _len, _ref;
      ret = Organization.__super__.toJSON.call(this, opts);
      _ref = ret['children'];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        c = _ref[_i];
        c.view_url = VIEW_URLS['policymaker-details'].replace('ID', c.slug);
      }
      return ret;
    };

    return Organization;

  })(Backbone.Tastypie.Model);

  this.OrganizationList = (function(_super) {
    __extends(OrganizationList, _super);

    function OrganizationList() {
      return OrganizationList.__super__.constructor.apply(this, arguments);
    }

    OrganizationList.prototype.urlRoot = API_PREFIX + 'v1/organization/';

    OrganizationList.prototype.model = Organization;

    return OrganizationList;

  })(Backbone.Tastypie.Collection);

}).call(this);
